param([String]$working=$pwd, [String]$desktop = [Environment]::GetFolderPath("Desktop"))
$iGPUpci = "PCI\VEN_1002&DEV_1681&SUBSYS_380117AA&REV_C1\4&33381BD1&0&0041"
$dGPUpci = "PCI\VEN_10DE&DEV_1B80&SUBSYS_85AA1043&REV_A1\6&5c8cf2c&0&00080019"

$folderPath = "C:\.gpu" #do not change unless you change it in GPU.xml as well
$gpuTask = Join-Path $working GPU.xml #just do not change
if (!([Security.Principal.WindowsPrincipal][Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] "Administrator")) { Start-Process powershell.exe "-NoProfile -ExecutionPolicy Bypass -File `"$PSCommandPath`" -working $pwd -desktop $desktop" -Verb RunAs; exit }

$scriptOld = Join-Path $working "*"
$linkEnableOrig = Join-Path $folderPath "enableigpu.ps1"
$linkEnableDesk = Join-Path $desktop "Enable-iGPU"
$linkDisableOrig = Join-Path $folderPath "disableigpu.ps1"
$linkDisableDesk = Join-Path $desktop "Disable-iGPU"
Write-Output "Testing if files exist"
if(-Not (Test-Path $folderPath)){
	Write-Output "Creating Directory $folderPath"
	New-Item $folderPath -Type Directory
	attrib +h $folderPath
	Copy-Item $scriptOld $folderPath
	
	New-Item -ItemType SymbolicLink -Path $linkEnableDesk -Target $linkEnableOrig 
	New-Item -ItemType SymbolicLink -Path $linkDisableDesk -Target $linkDisableOrig 
}


Write-Output "Checking if task already exists"
if(Get-ScheduledTask | Where-Object{$_.TaskName -eq "GPU"})
{
	Write-Output "Task exists"
}else
{
	Register-ScheduledTask -TaskName "GPU" -Xml (Get-Content $gpuTask | Out-String)
}


Write-Output "Waiting 5 Seconds"
Start-Sleep 5
if(Get-PnpDevice | Where-Object{$_.InstanceId -eq $dGPUpci} | Where-Object{$_.Status -eq "OK"})
{
	Write-Output "dGPU plugged in"
	if(Get-PnpDevice | Where-Object{$_.InstanceId -eq $iGPUpci} | Where-Object{$_.Status -eq "OK"})
	{
		Write-Output "Disabling iGPU"
		pnputil /disable-device $iGPUpci #disable iGPU
	}else
	{
		Write-Output "iGPU already disabled"
	}
}else
{
	Write-Output "dGPU not plugged in"
	if(Get-PnpDevice | Where-Object{$_.InstanceId -eq $iGPUpci} | Where-Object{$_.Status -eq "OK"})
	{
		Write-Output "iGPU already enabled"
	}else
	{
		Write-Output "Enabling iGPU"
		pnputil /enable-device $iGPUpci #enable iGPU
	}
}
